[BACK]Return to rc CVS log [TXT][DIR] Up to [local] / src / etc

Annotation of src/etc/rc, Revision 1.570

1.570   ! asou        1: #      $OpenBSD: rc,v 1.569 2023/01/18 20:44:40 deraadt Exp $
1.1       deraadt     2:
1.450     rpe         3: # System startup script run by init on autoboot or after single-user.
                      4: # Output and error are redirected to console by init, and the console is the
                      5: # controlling terminal.
1.454     rpe         6:
                      7: # Turn off Strict Bourne shell.
                      8: set +o sh
1.1       deraadt     9:
1.131     millert    10: # Subroutines (have to come first).
                     11:
1.456     rpe        12: # Strip in- and whole-line comments from a file.
                     13: # Strip leading and trailing whitespace if IFS is set.
                     14: # Usage: stripcom /path/to/file
1.131     millert    15: stripcom() {
1.456     rpe        16:        local _file=$1 _line
1.131     millert    17:
1.456     rpe        18:        [[ -s $_file ]] || return
                     19:
                     20:        while read _line ; do
                     21:                _line=${_line%%#*}
                     22:                [[ -n $_line ]] && print -r -- "$_line"
                     23:        done <$_file
1.131     millert    24: }
                     25:
1.456     rpe        26: # Update resource limits based on login.conf settings.
                     27: # Usage: update_limit -flag capability
1.265     millert    28: update_limit() {
1.456     rpe        29:        local _flag=$1          # ulimit flag
                     30:        local _cap=$2 _val      # login.conf capability and its value
                     31:        local _suffix
                     32:
1.490     otto       33:        for _suffix in {,-max,-cur}; do
1.456     rpe        34:                _val=$(getcap -f /etc/login.conf -s ${_cap}${_suffix} daemon 2>/dev/null)
                     35:                [[ -n $_val ]] || continue
                     36:                [[ $_val == infinity ]] && _val=unlimited
                     37:
                     38:                case $_suffix in
                     39:                -cur)   ulimit -S $_flag $_val
                     40:                        ;;
                     41:                -max)   ulimit -H $_flag $_val
                     42:                        ;;
                     43:                *)      ulimit $_flag $_val
                     44:                        return
                     45:                        ;;
                     46:                esac
1.265     millert    47:        done
                     48: }
                     49:
1.457     rpe        50: # Apply sysctl.conf(5) settings.
1.265     millert    51: sysctl_conf() {
1.520     bluhm      52:        # do not use a pipe as limits would only be applied to the subshell
                     53:        set -- $(stripcom /etc/sysctl.conf)
                     54:        while [[ $# > 0 ]] ; do
                     55:                sysctl "$1"
1.267     millert    56:
1.520     bluhm      57:                case "$1" in
1.265     millert    58:                kern.maxproc=*)
1.520     bluhm      59:                        update_limit -p maxproc
                     60:                        ;;
1.265     millert    61:                kern.maxfiles=*)
1.520     bluhm      62:                        update_limit -n openfiles
                     63:                        ;;
1.265     millert    64:                esac
1.520     bluhm      65:                shift
1.265     millert    66:        done
                     67: }
                     68:
1.457     rpe        69: # Apply mixerctl.conf(5) settings.
1.452     rpe        70: mixerctl_conf() {
1.457     rpe        71:        stripcom /etc/mixerctl.conf |
                     72:        while read _line; do
                     73:                mixerctl -q "$_line" 2>/dev/null
1.265     millert    74:        done
                     75: }
                     76:
1.457     rpe        77: # Apply wsconsctl.conf(5) settings.
1.452     rpe        78: wsconsctl_conf() {
1.457     rpe        79:        [[ -x /sbin/wsconsctl ]] || return
1.267     millert    80:
1.457     rpe        81:        stripcom /etc/wsconsctl.conf |
                     82:        while read _line; do
1.458     rpe        83:                eval "wsconsctl $_line"
1.267     millert    84:        done
                     85: }
                     86:
1.495     rpe        87: # Push the old seed into the kernel, create a future seed  and create a seed
                     88: # file for the boot-loader.
1.452     rpe        89: random_seed() {
1.427     bluhm      90:        dd if=/var/db/host.random of=/dev/random bs=65536 count=1 status=none
                     91:        chmod 600 /var/db/host.random
                     92:        dd if=/dev/random of=/var/db/host.random bs=65536 count=1 status=none
                     93:        dd if=/dev/random of=/etc/random.seed bs=512 count=1 status=none
                     94:        chmod 600 /etc/random.seed
1.312     djm        95: }
                     96:
1.450     rpe        97: # Populate net.inet.(tcp|udp).baddynamic with the contents of /etc/services so
                     98: # as to avoid randomly allocating source ports that correspond to well-known
1.451     rpe        99: # services.
1.459     rpe       100: # Usage: fill_baddynamic tcp|udp
1.452     rpe       101: fill_baddynamic() {
1.390     halex     102:        local _service=$1
1.318     djm       103:        local _sysctl="net.inet.${_service}.baddynamic"
1.459     rpe       104:
1.390     halex     105:        stripcom /etc/services |
                    106:        {
1.459     rpe       107:                _ban=
1.390     halex     108:                while IFS="     /" read _name _port _srv _junk; do
1.459     rpe       109:                        [[ $_srv == $_service ]] || continue
                    110:
                    111:                        _ban="${_ban:+$_ban,}+$_port"
                    112:
1.390     halex     113:                        # Flush before argv gets too long
1.459     rpe       114:                        if ((${#_ban} > 1024)); then
                    115:                                sysctl -q "$_sysctl=$_ban"
                    116:                                _ban=
1.390     halex     117:                        fi
                    118:                done
1.459     rpe       119:                [[ -n $_ban ]] && sysctl -q "$_sysctl=$_ban"
1.390     halex     120:        }
1.318     djm       121: }
                    122:
1.450     rpe       123: # Start daemon using the rc.d daemon control scripts.
1.451     rpe       124: # Usage: start_daemon daemon1 daemon2 daemon3
1.452     rpe       125: start_daemon() {
1.460     rpe       126:        local _daemon
                    127:
                    128:        for _daemon; do
                    129:                eval "_do=\${${_daemon}_flags}"
                    130:                [[ $_do != NO ]] && /etc/rc.d/${_daemon} start
1.353     robert    131:        done
                    132: }
                    133:
1.469     tim       134: # Generate keys for isakmpd, iked and sshd if they don't exist yet.
1.452     rpe       135: make_keys() {
1.460     rpe       136:        local _isakmpd_key=/etc/isakmpd/private/local.key
                    137:        local _isakmpd_pub=/etc/isakmpd/local.pub
                    138:        local _iked_key=/etc/iked/private/local.key
                    139:        local _iked_pub=/etc/iked/local.pub
                    140:
                    141:        if [[ ! -f $_isakmpd_key ]]; then
1.560     tobhe     142:                echo -n "openssl: generating isakmpd RSA keys... "
1.460     rpe       143:                if openssl genrsa -out $_isakmpd_key 2048 >/dev/null 2>&1 &&
                    144:                        chmod 600 $_isakmpd_key &&
                    145:                        openssl rsa -out $_isakmpd_pub -in $_isakmpd_key \
                    146:                            -pubout >/dev/null 2>&1; then
1.373     deraadt   147:                        echo done.
                    148:                else
                    149:                        echo failed.
                    150:                fi
                    151:        fi
                    152:
1.460     rpe       153:        if [[ ! -f $_iked_key ]]; then
1.560     tobhe     154:                echo -n "openssl: generating iked ECDSA keys... "
                    155:                if openssl ecparam -genkey -name prime256v1 -out $_iked_key >/dev/null 2>&1 &&
                    156:                        chmod 600 $_iked_key &&
                    157:                        openssl ec -out $_iked_pub -in $_iked_key \
                    158:                            -pubout >/dev/null 2>&1; then
                    159:                        echo done.
                    160:                else
                    161:                        echo failed.
                    162:                fi
1.373     deraadt   163:        fi
                    164:
                    165:        ssh-keygen -A
1.524     florian   166:
                    167:        if [[ ! -f /etc/soii.key ]]; then
1.525     rpe       168:                openssl rand -hex 16 > /etc/soii.key &&
1.524     florian   169:                    chmod 600 /etc/soii.key && sysctl -q \
                    170:                    "net.inet6.ip6.soiikey=$(</etc/soii.key)"
                    171:        fi
1.373     deraadt   172: }
                    173:
1.483     rpe       174: # Re-link libraries, placing the objects in a random order.
1.481     rpe       175: reorder_libs() {
1.521     rpe       176:        local _error=false _dkdev _liba _libas _mp _ro_list _tmpdir
1.522     rpe       177:        local _relink=/usr/share/relink
1.498     tb        178:
                    179:        [[ $library_aslr == NO ]] && return
                    180:
1.521     rpe       181:        # Skip if /usr/lib, /usr/libexec or /usr/share/relink are on nfs mounted
                    182:        # filesystems, otherwise record which ones are mounted read-only.
1.533     kn        183:        for _dkdev in $(df /usr/{lib,libexec} $_relink |
                    184:            sed '1d;s/ .*//' | sort -u); do
                    185:                _mp=$(mount -t ffs | grep "^$_dkdev") || return
                    186:                if [[ $_mp == *read-only* ]]; then
                    187:                        _ro_list="$_ro_list ${_mp%% *}"
1.521     rpe       188:                fi
                    189:        done
1.484     rpe       190:
1.569     deraadt   191:        echo 'reordering:'
1.523     tb        192:
1.556     jsg       193:        # Remount the (read-only) filesystems in _ro_list as read-write.
1.521     rpe       194:        for _mp in $_ro_list; do
                    195:                if ! mount -u -w $_mp; then
1.565     cheloha   196:                        echo '(failed).'
1.481     rpe       197:                        return
                    198:                fi
1.521     rpe       199:        done
1.509     tb        200:
                    201:        # Only choose the latest version of the libraries.
1.522     rpe       202:        for _liba in $_relink/usr/lib/lib{c,crypto}; do
1.513     zhuk      203:                _libas="$_libas $(ls $_liba.so.+([0-9.]).a | sort -rV | head -1)"
1.509     tb        204:        done
1.481     rpe       205:
1.522     rpe       206:        for _liba in $_relink/usr/libexec/ld.so.a $_libas; do
                    207:                _tmpdir=$(mktemp -dq $_relink/_rebuild.XXXXXXXXXXXX) &&
1.517     rpe       208:                (
                    209:                set -o errexit
1.534     kn        210:                _install='install -F -o root -g bin -m 0444'
1.517     rpe       211:                _lib=${_liba##*/}
                    212:                _lib=${_lib%.a}
1.522     rpe       213:                _lib_dir=${_liba#$_relink}
1.523     tb        214:                _lib_dir=${_lib_dir%/*}
1.517     rpe       215:                cd $_tmpdir
                    216:                ar x $_liba
                    217:                if [[ $_lib == ld.so ]]; then
1.566     florian   218:                        echo " $_lib"
1.537     guenther  219:                        args="-g -x -e _dl_start \
1.517     rpe       220:                            --version-script=Symbols.map --shared -Bsymbolic \
1.537     guenther  221:                            --no-undefined"
                    222:                        [[ -f ld.script ]] && args="$args -T ld.script"
                    223:                        ld $args -o ld.so.test $(ls *.o | sort -R)
1.517     rpe       224:                        chmod u+x test-ld.so
                    225:                        [[ $(./test-ld.so ok) == './test-ld.so: ok!' ]]
                    226:                        $_install /usr/libexec/ld.so /usr/libexec/ld.so.save
1.521     rpe       227:                        $_install ld.so.test $_lib_dir/ld.so
1.517     rpe       228:                else
1.566     florian   229:                        echo " ${_lib%%.*}"
1.541     naddy     230:                        cc -shared -o $_lib $(ls *.so | sort -R) $(<.ldadd)
1.475     deraadt   231:                        [[ -s $_lib ]] && file $_lib | fgrep -q 'shared object'
                    232:                        LD_BIND_NOW=1 LD_LIBRARY_PATH=$_tmpdir awk 'BEGIN {exit 0}'
1.500     deraadt   233:                        LD_BIND_NOW=1 LD_LIBRARY_PATH=$_tmpdir openssl \
                    234:                            x509 -in /etc/ssl/cert.pem -out /dev/null
1.521     rpe       235:                        $_install $_lib $_lib_dir/$_lib
1.517     rpe       236:                fi
1.485     rpe       237:                ) || { _error=true; break; }
1.475     deraadt   238:        done
1.481     rpe       239:
1.569     deraadt   240:        for _bin in $_relink/usr/sbin/sshd; do
                    241:                _tmpdir=$(mktemp -dq $_relink/_rebuild.XXXXXXXXXXXX) &&
                    242:                (
                    243:                set -o errexit
                    244:                cd $_tmpdir
                    245:                _binn=${_bin##*/}
                    246:                _bint=${_bin}/${_binn}.tar
                    247:                if [[ -f $_bint ]]; then
                    248:                        echo " $_binn"
                    249:                        tar xf $_bint
                    250:                        make -f Makefile.relink relink >/dev/null 2>&1
                    251:                fi
                    252:                ) || { _error=true; break; }
                    253:        done
1.570   ! asou      254:
1.522     rpe       255:        rm -rf $_relink/_rebuild.*
1.485     rpe       256:
1.481     rpe       257:        # Restore previous mount state if it was changed.
1.521     rpe       258:        for _mp in $_ro_list; do
                    259:                mount -u -r $_mp || _error=true
                    260:        done
1.482     deraadt   261:
1.485     rpe       262:        if $_error; then
1.565     cheloha   263:                echo '(failed).'
1.485     rpe       264:        else
1.565     cheloha   265:                echo '.'
1.485     rpe       266:        fi
1.475     deraadt   267: }
                    268:
1.566     florian   269: # Read output of reorder_libs co-process and output on console.
                    270: wait_reorder_libs() {
                    271:        local _line
1.568     kn        272:
                    273:        [[ $library_aslr == NO ]] && return
1.567     kn        274:
1.566     florian   275:        while IFS= read -p _line; do
                    276:                echo -n "$_line"
                    277:        done
                    278:        echo
                    279: }
                    280:
1.483     rpe       281: # Run rc.* script and email output to root.
                    282: # Usage: run_upgrade_script firsttime|sysmerge
1.477     ajacouto  283: run_upgrade_script() {
                    284:        local _suffix=$1
1.491     rpe       285:
1.477     ajacouto  286:        [[ -n $_suffix ]] || return 1
1.491     rpe       287:
1.477     ajacouto  288:        if [[ -f /etc/rc.$_suffix ]]; then
1.516     ajacouto  289:                echo "running rc.$_suffix"
1.477     ajacouto  290:                mv /etc/rc.$_suffix /etc/rc.$_suffix.run
                    291:                . /etc/rc.$_suffix.run 2>&1 | tee /dev/tty |
                    292:                        mail -Es "$(hostname) rc.$_suffix output" root >/dev/null
                    293:        fi
                    294:        rm -f /etc/rc.$_suffix.run
                    295: }
                    296:
1.462     rpe       297: # Check filesystems, optionally by using a fsck(8) flag.
                    298: # Usage: do_fsck [-flag]
1.452     rpe       299: do_fsck() {
1.462     rpe       300:        fsck -p "$@"
1.429     claudio   301:        case $? in
1.462     rpe       302:        0)      ;;
                    303:        2)      exit 1
1.429     claudio   304:                ;;
1.462     rpe       305:        4)      echo "Rebooting..."
1.429     claudio   306:                reboot
                    307:                echo "Reboot failed; help!"
                    308:                exit 1
                    309:                ;;
1.462     rpe       310:        8)      echo "Automatic file system check failed; help!"
1.429     claudio   311:                exit 1
                    312:                ;;
1.462     rpe       313:        12)     echo "Boot interrupted."
1.429     claudio   314:                exit 1
                    315:                ;;
1.462     rpe       316:        130)    # Interrupt before catcher installed.
1.429     claudio   317:                exit 1
                    318:                ;;
1.462     rpe       319:        *)      echo "Unknown error; help!"
1.429     claudio   320:                exit 1
                    321:                ;;
                    322:        esac
                    323: }
                    324:
1.450     rpe       325: # End subroutines.
1.131     millert   326:
1.1       deraadt   327: stty status '^T'
                    328:
1.450     rpe       329: # Set shell to ignore SIGINT (2), but not children; shell catches SIGQUIT (3)
                    330: # and returns to single user after fsck.
1.1       deraadt   331: trap : 2
1.450     rpe       332: trap : 3       # Shouldn't be needed.
1.1       deraadt   333:
1.463     rpe       334: export HOME=/
                    335: export INRC=1
                    336: export PATH=/sbin:/bin:/usr/sbin:/usr/bin
1.544     deraadt   337:
                    338: # /etc/myname contains my symbolic name.
                    339: if [[ -f /etc/myname ]]; then
                    340:        hostname "$(stripcom /etc/myname)"
                    341: fi
1.395     deraadt   342:
1.450     rpe       343: # Must set the domainname before rc.conf, so YP startup choices can be made.
1.563     miod      344: if [[ -s /etc/defaultdomain && -z "$(sysctl -n kern.domainname)" ]]; then
1.463     rpe       345:        domainname "$(stripcom /etc/defaultdomain)"
1.395     deraadt   346: fi
1.108     deraadt   347:
1.495     rpe       348: # Get local functions from rc.subr to load rc.conf into scope.
1.428     robert    349: FUNCS_ONLY=1 . /etc/rc.d/rc.subr
                    350: _rc_parse_conf
1.343     robert    351:
1.495     rpe       352: # If executed with the 'shutdown' parameter by the halt, reboot or shutdown:
                    353: # - update seed files
                    354: # - execute the rc.d scripts specified by $pkg_scripts in reverse order
                    355: # - bring carp interfaces down gracefully
1.463     rpe       356: if [[ $1 == shutdown ]]; then
1.525     rpe       357:        if echo 2>/dev/null >>/var/db/host.random ||
1.437     bluhm     358:            echo 2>/dev/null >>/etc/random.seed; then
                    359:                random_seed
                    360:        else
                    361:                echo warning: cannot write random seed to disk
                    362:        fi
1.416     rpe       363:
1.469     tim       364:        # If we are in secure level 0, assume single user mode.
1.463     rpe       365:        if (($(sysctl -n kern.securelevel) == 0)); then
                    366:                echo 'single user: not running shutdown scripts'
                    367:        else
1.514     rpe       368:                set -A _d -- $pkg_scripts
                    369:                _i=${#_d[*]}
                    370:                if ((_i)); then
1.413     deraadt   371:                        echo -n 'stopping package daemons:'
1.514     rpe       372:                        while ((--_i >= 0)); do
                    373:                                [[ -x /etc/rc.d/${_d[_i]} ]] &&
                    374:                                        /etc/rc.d/${_d[_i]} stop
1.413     deraadt   375:                        done
1.527     sthen     376:                        echo '.'
                    377:                fi
                    378:
                    379:                if /etc/rc.d/vmd check > /dev/null; then
                    380:                        echo -n 'stopping VMs'
                    381:                        /etc/rc.d/vmd stop > /dev/null
1.413     deraadt   382:                        echo '.'
                    383:                fi
                    384:
1.463     rpe       385:                [[ -f /etc/rc.shutdown ]] && sh /etc/rc.shutdown
1.413     deraadt   386:        fi
1.240     mcbride   387:
1.463     rpe       388:        ifconfig | while read _if _junk; do
1.474     rpe       389:                [[ $_if == carp+([0-9]): ]] && ifconfig ${_if%:} down
1.413     deraadt   390:        done
1.246     mcbride   391:
1.108     deraadt   392:        exit 0
1.1       deraadt   393: fi
1.98      jakob     394:
1.540     deraadt   395: # If bootblocks failed to give us random, try to cause some churn
                    396: (dmesg; sysctl hw.{uuid,serialno,sensors} ) >/dev/random 2>&1
                    397:
1.482     deraadt   398: # Add swap block-devices.
1.172     miod      399: swapctl -A -t blk
1.170     deraadt   400:
1.495     rpe       401: # Run filesystem check unless a /fastboot file exists.
1.463     rpe       402: if [[ -e /fastboot ]]; then
1.1       deraadt   403:        echo "Fast boot: skipping disk checks."
1.463     rpe       404: elif [[ $1 == autoboot ]]; then
1.1       deraadt   405:        echo "Automatic boot in progress: starting file system checks."
1.429     claudio   406:        do_fsck
1.1       deraadt   407: fi
                    408:
1.495     rpe       409: # From now on, allow user to interrupt (^C) the boot process.
1.1       deraadt   410: trap "echo 'Boot interrupted.'; exit 1" 3
                    411:
1.495     rpe       412: # Unmount all filesystems except root.
1.1       deraadt   413: umount -a >/dev/null 2>&1
1.495     rpe       414:
                    415: # Mount all filesystems except those of type NFS and VND.
1.303     grunk     416: mount -a -t nonfs,vnd
1.177     deraadt   417:
1.495     rpe       418: # Re-mount the root filesystem read/writeable. (root on nfs requires this,
                    419: # others aren't hurt.)
                    420: mount -uw /
1.499     deraadt   421: chmod og-rwx /bsd
1.503     deraadt   422: ln -fh /bsd /bsd.booted
1.495     rpe       423:
                    424: rm -f /fastboot
                    425:
1.505     tedu      426: # Set flags on ttys.
1.1       deraadt   427: ttyflags -a
1.77      angelos   428:
1.464     rpe       429: # Set keyboard encoding.
                    430: if [[ -x /sbin/kbd && -s /etc/kbdtype ]]; then
1.541     naddy     431:        kbd "$(</etc/kbdtype)"
1.252     mcbride   432: fi
                    433:
1.279     deraadt   434: wsconsctl_conf
                    435:
1.464     rpe       436: # Set initial temporary pf rule set.
                    437: if [[ $pf != NO ]]; then
1.511     rpe       438:        RULES="
1.510     rpe       439:        block all
                    440:        pass on lo0
                    441:        pass in proto tcp from any to any port ssh keep state
                    442:        pass out proto { tcp, udp } from any to any port domain keep state
                    443:        pass out inet proto icmp all icmp-type echoreq keep state
                    444:        pass out inet proto udp from any port bootpc to any port bootps
1.511     rpe       445:        pass in inet proto udp from any port bootps to any port bootpc"
1.510     rpe       446:
1.257     grange    447:        if ifconfig lo0 inet6 >/dev/null 2>&1; then
1.510     rpe       448:                RULES="$RULES
                    449:                pass out inet6 proto icmp6 all icmp6-type neighbrsol
                    450:                pass in inet6 proto icmp6 all icmp6-type neighbradv
                    451:                pass out inet6 proto icmp6 all icmp6-type routersol
                    452:                pass in inet6 proto icmp6 all icmp6-type routeradv
                    453:                pass out inet6 proto udp from any port dhcpv6-client to any port dhcpv6-server
                    454:                pass in inet6 proto udp from any port dhcpv6-server to any port dhcpv6-client"
1.257     grange    455:        fi
1.510     rpe       456:
                    457:        RULES="$RULES
                    458:        pass in proto carp keep state (no-sync)
                    459:        pass out proto carp !received-on any keep state (no-sync)"
                    460:
1.545     naddy     461:        if (($(sysctl -n vfs.mounts.nfs 2>/dev/null)+0 > 0)); then
1.511     rpe       462:                # Don't kill NFS.
1.510     rpe       463:                RULES="set reassemble yes no-df
                    464:                $RULES
                    465:                pass in proto { tcp, udp } from any port { sunrpc, nfsd } to any
                    466:                pass out proto { tcp, udp } from any to any port { sunrpc, nfsd } !received-on any"
1.474     rpe       467:        fi
1.511     rpe       468:
1.464     rpe       469:        print -- "$RULES" | pfctl -f -
1.269     dhartmei  470:        pfctl -e
1.176     kjell     471: fi
1.318     djm       472:
                    473: fill_baddynamic udp
                    474: fill_baddynamic tcp
1.176     kjell     475:
1.267     millert   476: sysctl_conf
1.260     jsg       477:
1.557     florian   478: mount -s /var >/dev/null 2>&1          # cannot be on NFS
                    479: mount -s /var/log >/dev/null 2>&1      # cannot be on NFS
1.564     deraadt   480: mount -s /usr >/dev/null 2>&1          # if NFS, fstab must use IP address
1.557     florian   481:
1.566     florian   482: reorder_libs 2>&1 |&
                    483:
1.557     florian   484: start_daemon slaacd dhcpleased resolvd >/dev/null 2>&1
1.501     florian   485:
1.1       deraadt   486: echo 'starting network'
1.464     rpe       487:
                    488: # Set carp interlock by increasing the demotion counter.
                    489: # Prevents carp from preempting until the system is booted.
1.536     tedu      490: ifconfig -g carp carpdemote 128
1.464     rpe       491:
1.439     ajacouto  492: sh /etc/netstart
1.542     deraadt   493:
1.557     florian   494: start_daemon unwind >/dev/null 2>&1
1.542     deraadt   495:
1.550     deraadt   496: random_seed
                    497:
1.566     florian   498: wait_reorder_libs
1.550     deraadt   499:
1.450     rpe       500: # Load pf rules and bring up pfsync interface.
1.464     rpe       501: if [[ $pf != NO ]]; then
                    502:        if [[ -f /etc/pf.conf ]]; then
1.449     ajacouto  503:                pfctl -f /etc/pf.conf
1.309     mpf       504:        fi
1.464     rpe       505:        if [[ -f /etc/hostname.pfsync0 ]]; then
1.435     deraadt   506:                sh /etc/netstart pfsync0
1.367     deraadt   507:        fi
1.176     kjell     508: fi
1.29      deraadt   509:
1.450     rpe       510: # Clean up left-over files.
1.492     jca       511: rm -f /etc/nologin /var/spool/lock/LCK.*
1.247     henning   512: (cd /var/run && { rm -rf -- *; install -c -m 664 -g utmp /dev/null utmp; })
1.196     beck      513: (cd /var/authpf && rm -rf -- *)
1.96      alex      514:
1.495     rpe       515: # Save a copy of the boot messages.
                    516: dmesg >/var/run/dmesg.boot
1.55      deraadt   517:
1.373     deraadt   518: make_keys
                    519:
1.379     deraadt   520: echo -n 'starting early daemons:'
1.543     tedu      521: start_daemon syslogd ldattach pflogd nsd unbound ntpd
1.429     claudio   522: start_daemon iscsid isakmpd iked sasyncd ldapd npppd
1.353     robert    523: echo '.'
1.280     hshoexer  524:
1.450     rpe       525: # Load IPsec rules.
1.464     rpe       526: if [[ $ipsec != NO && -f /etc/ipsec.conf ]]; then
                    527:        ipsecctl -f /etc/ipsec.conf
1.40      provos    528: fi
1.1       deraadt   529:
1.379     deraadt   530: echo -n 'starting RPC daemons:'
1.562     deraadt   531: start_daemon portmap
1.464     rpe       532: if [[ -n $(domainname) ]]; then
1.562     deraadt   533:        start_daemon ypldap ypserv ypbind
1.376     deraadt   534: fi
1.399     dlg       535: start_daemon mountd nfsd lockd statd amd
1.1       deraadt   536: echo '.'
1.58      deraadt   537:
1.464     rpe       538: # Check and mount remaining file systems and enable additional swap.
1.278     otto      539: mount -a
1.172     miod      540: swapctl -A -t noblk
1.429     claudio   541: do_fsck -N
                    542: mount -a -N
1.1       deraadt   543:
1.549     deraadt   544: # Build kvm(3) and /dev databases.
                    545: kvm_mkdb
                    546: dev_mkdb
                    547:
1.450     rpe       548: # /var/crash should be a directory or a symbolic link to the crash directory
                    549: # if core dumps are to be saved.
1.464     rpe       550: if [[ -d /var/crash ]]; then
                    551:        savecore $savecore_flags /var/crash
1.487     rpe       552: fi
                    553:
                    554: # Store ACPI tables in /var/db/acpi to be used by sendbug(1).
                    555: if [[ -x /usr/sbin/acpidump ]]; then
1.530     kettenis  556:        acpidump -q -o /var/db/acpi/
1.90      art       557: fi
                    558:
1.464     rpe       559: if [[ $check_quotas == YES ]]; then
1.41      downsj    560:        echo -n 'checking quotas:'
                    561:        quotacheck -a
                    562:        echo ' done.'
                    563:        quotaon -a
                    564: fi
1.464     rpe       565:
                    566: # Set proper permission for the tty device files.
1.101     deraadt   567: chmod 666 /dev/tty[pqrstuvwxyzPQRST]*
1.226     millert   568: chown root:wheel /dev/tty[pqrstuvwxyzPQRST]*
1.1       deraadt   569:
1.495     rpe       570: # Check for the password temp/lock file.
1.467     rpe       571: if [[ -f /etc/ptmp ]]; then
1.1       deraadt   572:        logger -s -p auth.err \
1.376     deraadt   573:            'password file may be incorrect -- /etc/ptmp exists'
1.32      deraadt   574: fi
                    575:
1.49      millert   576: echo clearing /tmp
                    577:
1.450     rpe       578: # Prune quickly with one rm, then use find to clean up /tmp/[lqv]*
                    579: # (not needed with mfs /tmp, but doesn't hurt there...).
1.444     deraadt   580: (cd /tmp && rm -rf [a-km-pr-uw-zA-Z]*)
1.339     sthen     581: (cd /tmp &&
1.443     millert   582:     find . -maxdepth 1 ! -name . ! -name lost+found ! -name quota.user \
1.444     deraadt   583:        ! -name quota.group ! -name vi.recover -execdir rm -rf -- {} \;)
1.373     deraadt   584:
1.462     rpe       585: # Create Unix sockets directories for X if needed and make sure they have
                    586: # correct permissions.
                    587: [[ -d /usr/X11R6/lib ]] && mkdir -m 1777 /tmp/.{X11,ICE}-unix
1.203     hugh      588:
1.467     rpe       589: [[ -f /etc/rc.securelevel ]] && sh /etc/rc.securelevel
                    590:
1.450     rpe       591: # rc.securelevel did not specifically set -1 or 2, so select the default: 1.
1.467     rpe       592: (($(sysctl -n kern.securelevel) == 0)) && sysctl kern.securelevel=1
                    593:
1.1       deraadt   594:
1.450     rpe       595: # Patch /etc/motd.
1.467     rpe       596: if [[ ! -f /etc/motd ]]; then
1.34      deraadt   597:        install -c -o root -g wheel -m 664 /dev/null /etc/motd
                    598: fi
1.467     rpe       599: if T=$(mktemp /tmp/_motd.XXXXXXXXXX); then
1.451     rpe       600:        sysctl -n kern.version | sed 1q >$T
1.494     schwarze  601:        sed -n '/^$/,$p' </etc/motd >>$T
1.102     millert   602:        cmp -s $T /etc/motd || cp $T /etc/motd
                    603:        rm -f $T
                    604: fi
1.34      deraadt   605:
1.467     rpe       606: if [[ $accounting == YES ]]; then
                    607:        [[ ! -f /var/account/acct ]] && touch /var/account/acct
                    608:        echo 'turning on accounting'
                    609:        accton /var/account/acct
1.1       deraadt   610: fi
                    611:
1.467     rpe       612: if [[ -x /sbin/ldconfig ]]; then
1.115     deraadt   613:        echo 'creating runtime link editor directory cache.'
1.471     rpe       614:        [[ -d /usr/local/lib ]] && shlib_dirs="/usr/local/lib $shlib_dirs"
1.467     rpe       615:        [[ -d /usr/X11R6/lib ]] && shlib_dirs="/usr/X11R6/lib $shlib_dirs"
1.115     deraadt   616:        ldconfig $shlib_dirs
1.231     millert   617: fi
                    618:
1.451     rpe       619: echo 'preserving editor files.'; /usr/libexec/vi.recover
1.244     markus    620:
1.477     ajacouto  621: # If rc.sysmerge exists, run it just once, and make sure it is deleted.
                    622: run_upgrade_script sysmerge
                    623:
1.353     robert    624: echo -n 'starting network daemons:'
1.555     claudio   625: start_daemon ldomd sshd snmpd ldpd ripd ospfd ospf6d bgpd ifstated
1.529     florian   626: start_daemon relayd dhcpd dhcrelay mrouted dvmrpd radiusd eigrpd route6d
1.559     claudio   627: start_daemon rad hostapd lpd smtpd slowcgi bgplgd httpd ftpd
1.461     sthen     628: start_daemon ftpproxy ftpproxy6 tftpd tftpproxy identd inetd rarpd bootparamd
1.488     reyk      629: start_daemon rbootd mopd vmd spamd spamlogd sndiod
1.377     robert    630: echo '.'
1.335     deraadt   631:
1.450     rpe       632: # If rc.firsttime exists, run it just once, and make sure it is deleted.
1.477     ajacouto  633: run_upgrade_script firsttime
1.352     ajacouto  634:
1.450     rpe       635: # Run rc.d(8) scripts from packages.
1.467     rpe       636: if [[ -n $pkg_scripts ]]; then
1.352     ajacouto  637:        echo -n 'starting package daemons:'
1.467     rpe       638:        for _daemon in $pkg_scripts; do
                    639:                if [[ -x /etc/rc.d/$_daemon ]]; then
                    640:                        start_daemon $_daemon
1.410     espie     641:                else
1.467     rpe       642:                        echo -n " ${_daemon}(absent)"
1.410     espie     643:                fi
1.352     ajacouto  644:        done
                    645:        echo '.'
                    646: fi
1.17      deraadt   647:
1.467     rpe       648: [[ -f /etc/rc.local ]] && sh /etc/rc.local
1.73      millert   649:
1.495     rpe       650: # Disable carp interlock.
1.536     tedu      651: ifconfig -g carp -carpdemote 128
1.286     mcbride   652:
1.379     deraadt   653: mixerctl_conf
1.467     rpe       654:
1.379     deraadt   655: echo -n 'starting local daemons:'
1.493     matthieu  656: start_daemon apmd sensorsd hotplugd watchdogd cron wsmoused xenodm
1.73      millert   657: echo '.'
1.502     rpe       658:
1.515     rpe       659: # Re-link the kernel, placing the objects in a random order.
                    660: # Replace current with relinked kernel and inform root about it.
                    661: /usr/libexec/reorder_kernel &
1.1       deraadt   662:
                    663: date
                    664: exit 0